-- the commands

-- help command
COM_AddCommand("gms_help", function(player, arg)
	CONS_Printf(player, "\x82".."Commands available:".."\x80"..": gms_propellernoise, gms_bounstomp, gms_betahud, gms_credits")
	CONS_Printf(player, "Type them in for descriptions!")
end)

-- woah credits in a command??
COM_AddCommand("gms_credits", function(player, arg)
	CONS_Printf(player, "\x82".."Main developers".."\x80"..":")
	CONS_Printf(player, "\x82".."Terionic".."\x80"..": did most of the mod")
	CONS_Printf(player, "\x82".."ashi".."\x80"..": helped coding the hud and the gms_propellernoise command (yes that command took way more effort than it needed)")
	CONS_Printf(player, "\x82".."Samups".."\x80"..": drew the character select art")
	CONS_Printf(player, "\x82".."Reused content".."\x80"..":")
	CONS_Printf(player, "\x82".."Sz".."\x80"..": SSNMighty (breakable floor code, reusable)")
	CONS_Printf(player, "\x82".."Icezer".."\x80"..": Super Sonic (ring attraction code, reusable)")
	CONS_Printf(player, "\x82".."yfyfyfyfyfy".."\x80"..": Animated Skincolors (color scroll code, reusable)")
	CONS_Printf(player, "\x82".."CrystallineGazer".."\x80"..": HorizonChars (Metal Sonic dance sprites, got perms)")
	CONS_Printf(player, "\x82".."Testers".."\x80"..": ZharRDy, Kitarmix, SilusLange!, Samups")
end)

-- ring propeller sfx toggle
COM_AddCommand("gms_propellernoise", function(player, arg)
	-- display description and current value if there is no argument
	if arg == nil 
		if player.gmsnoise == true
			CONS_Printf(player, "\x82".."gms_propellernoise".."\x80"..": Toggles the noise the Ring Propeller produces, since it might be annoying to some players. Currently on")
		else
			CONS_Printf(player, "\x82".."gms_propellernoise".."\x80"..": Toggles the noise the Ring Propeller produces, since it might be annoying to some players. Currently off")
		end
	-- set to true
	elseif arg == "true"
	or arg == "1"
	or arg == "on"
		player.gmsnoise = true
		CONS_Printf(player, "Propeller noise is now on. Enjoy pain.")
		-- save options to luafiles
		local file = io.openlocal("client/terioswashere/gms_propellernoise.dat", "w+")
		file:write("true")
		file:close()
	-- set to false
	elseif arg == "false"
	or arg == "0"
	or arg == "off"
		player.gmsnoise = false
		CONS_Printf(player, "Propeller noise is now off. No more pain.")
		-- save options to luafiles
		local file = io.openlocal("client/terioswashere/gms_propellernoise.dat", "w+")
		file:write("false")
		file:close()
	else
		-- oop what you just said amounts to nothing
		CONS_Printf(player, "Invalid argument. Use on/off")
	end
end)

-- beta ring crush behavior toggle
COM_AddCommand("gms_bounstomp", function(player, arg)
	-- display description and current value if there is no argument
	if arg == nil 
		if player.gmsbetarc == true
			CONS_Printf(player, "\x82".."gms_bounstomp".."\x80"..": Toggles beta Ring Crush behavior, costing more but bouncing higher. Currently on")
		else
			CONS_Printf(player, "\x82".."gms_bounstomp".."\x80"..": Toggles beta Ring Crush behavior, costing more but bouncing higher. Currently off")
		end
	-- set to true
	elseif arg == "true"
	or arg == "1"
	or arg == "on"
		player.gmsbetarc = true
		CONS_Printf(player, "Beta Ring Crush behavior is now on!")
		-- save options to luafiles
		local file = io.openlocal("client/terioswashere/gms_bountomp.dat", "w+")
		file:write("true")
		file:close()
	-- set to false
	elseif arg == "false"
	or arg == "0"
	or arg == "off"
		player.gmsbetarc = false
		CONS_Printf(player, "Beta Ring Crush behavior is now off!")
		-- save options to luafiles
		local file = io.openlocal("client/terioswashere/gms_bountomp.dat", "w+")
		file:write("false")
		file:close()
	else
		-- oop what you just said amounts to nothing
		CONS_Printf(player, "Invalid argument. Use on/off")
	end
end)

-- beta hud behavior toggle
COM_AddCommand("gms_betahud", function(player, arg)
	-- display description and current value if there is no argument
	if arg == nil 
		if player.gmsbetahud == true
			CONS_Printf(player, "\x82".."gms_betahud".."\x80"..": Toggles the boring old text HUD. Currently on")
		else
			CONS_Printf(player, "\x82".."gms_betahud".."\x80"..": Toggles the boring old text HUD. Currently off")
		end
	-- set to true
	elseif arg == "true"
	or arg == "1"
	or arg == "on"
		player.gmsbetahud = true
		CONS_Printf(player, "Beta HUD is now on!")
		-- save options to luafiles
		local file = io.openlocal("client/terioswashere/gms_betahud.dat", "w+")
		file:write("true")
		file:close()
	-- set to false
	elseif arg == "false"
	or arg == "0"
	or arg == "off"
		player.gmsbetahud = false
		CONS_Printf(player, "Beta HUD is now off!")
		-- save options to luafiles
		local file = io.openlocal("client/terioswashere/gms_betahud.dat", "w+")
		file:write("false")
		file:close()
	else
		-- oop what you just said amounts to nothing
		CONS_Printf(player, "Invalid argument. Use on/off")
	end
end)