-- jump and spin abilities for golden sonic
-- i havent touched this code in ages and forgot how it works so i basically had to go over it as if i was decompiling it
-- added comments to make this... not happen again i guess
-- oh yeah also, ashi helped me a ton on implementing locally toggleable propeller noise. awesome shit

-- create the sound table for the command
local sndtbl = {}

-- This will sync sndtbl with everyone in the server so the sounds shouldn't desync between players
addHook("NetVars", function(net)
    sndtbl = net($)
end)

-- freeslottin'
freeslot("SPR2_GSSQ", "SPR2_GSST", "S_GMS_SQUASH", "S_GMS_STRETCH")

-- squash and stretch sprites to add "model support"
states[S_GMS_SQUASH] = {SPR_PLAY, SPR2_GSSQ|FF_ANIMATE, -1, nil, 4, 1, S_GMS_STRETCH}
spr2defaults[SPR2_GSSQ] = SPR2_ROLL
states[S_GMS_STRETCH] = {SPR_PLAY, SPR2_GSST, -1, nil, nil, nil, S_GMS_STRETCH}
spr2defaults[SPR2_GSST] = SPR2_ROLL

addHook("ThinkFrame", do
	for player in players.iterate
		-- load gmsnoise settings
		if player.gmsnoise == nil
			local file = io.openlocal("client/terioswashere/gms_propellernoise.dat", "r")
			if file
				local string = file:read("*a")
				if string == "false"
					player.gmsnoise = false
				else
					player.gmsnoise = true
				end
			else
				player.gmsnoise = true
			end
		end
		-- same for gmsbetarc
		if player.gmsbetarc == nil
			local file = io.openlocal("client/terioswashere/gms_bountomp.dat", "r")
			if file
				local string = file:read("*a")
				if string == "true"
					player.gmsbetarc = true
				else
					player.gmsbetarc = false
				end
			else
				player.gmsbetarc = false
			end
		end
		if (player.mo and player.mo.skin == "gms")
				-- just in case
				if not player.gmsflight
					sndtbl[player.name] = nil
				end
				-- all last minute bug fixes are up here because i was too lazy to integrate it into the rest of the code! my code is already a mess anyways
				-- i forgor to add a ground check for the float because i never thought that would ever be possible. and it apparently is.
				if P_IsObjectOnGround(player.mo)
					sndtbl[player.name] = nil
					S_StopSoundByID(player.mo, sfx_jet)
					player.gmsflight = nil
				end
			-- cancel all shit if carry power (to prevent interaction issues)
			-- fuck you zharrdy for finding bugs like the good beta tester you are!!
			-- oh yeah also death check to prevent death animation bug
			if player.powers[pw_carry] ~= CR_NONE
			or player.mo.state == S_PLAY_DEAD
				if player.gmsstomp
					player.pflags =  $&~PF_SPINNING
				end
				player.gmsflight = nil
				player.gmsstomp = nil
				sndtbl[player.name] = nil
				S_StopSoundByID(player.mo, sfx_jet)
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
			end
			-- cancel stomp in goo to prevent getting stuck at rock bottom
			if player.mo.eflags & MFE_GOOWATER
			and player.gmsstomp
				player.gmsstomp = nil
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				player.mo.state = S_PLAY_ROLL
			end
			-- multiplies actionspd (ring thrust speed) if super
			if player.powers[pw_super]
				player.actionspd = player.normalspeed*(3/2)
			else
				player.actionspd = player.normalspeed
			end
			-- makes sure the thrust cooldown exists and substracts from it if its higher than 0
			if not player.gmsdashcooldown
				player.gmsdashcooldown = 0
			elseif player.gmsdashcooldown > 0
				player.gmsdashcooldown = $-1
			end
			-- checks if youve been holding jump from the ground or not
			if player.cmd.buttons & BT_JUMP
			and player.pflags & PF_JUMPED
			and not player.jumpground
			and not player.jumpgroundreleased
				player.jumpground = true
			elseif player.jumpground
			and not(player.cmd.buttons & BT_JUMP)
				player.jumpground = nil
				player.jumpgroundreleased = true
			elseif P_IsObjectOnGround(player.mo)
			and(player.jumpground or player.jumpgroundreleased)
				player.jumpground = nil
				player.jumpgroundreleased = nil
			end
			-- jump and spin tap detection scripts
			-- i think theres a vanilla flag that lets you check this simpler but i never got it to work
			-- i definitely did not copy this code from the wiki
			if not (player.cmd.buttons & BT_JUMP) then
				player.jumptapready = true
				player.jumptapping = false
			elseif player.jumptapready then
				player.jumptapping = true
				player.jumptapready = false
			else
				player.jumptapping = false
			end
			if not (player.cmd.buttons & BT_SPIN) then
				player.spintapready = true
				player.spintapping = false
			elseif player.spintapready then
				player.spintapping = true
				player.spintapready = false
			else
				player.spintapping = false
			end
			-- yes i cloned this input tap detection code to be able to disable abilities for a frame after dropping off of pw_carry flags.
			-- it works soooooo
			if player.powers[pw_carry] ~= CR_NONE then
				player.uncarryready = true
				player.uncarry = false
			elseif player.uncarryready then
				player.uncarry = true
				player.uncarryready = false
			else
				player.uncarry = false
			end
			-- flight trigger
			if player.jumptapping
			and not P_IsObjectOnGround(player.mo)
			and player.pflags & PF_JUMPED
			and player.jumpgroundreleased
			and not player.gmsflight
			and player.uncarry == false
			and player.powers[pw_carry] == CR_NONE
				player.gmsflight = 1
				player.pflags = $&~PF_JUMPED
				player.pflags = $&~PF_SPINNING
			end
			-- flight code loop
			if player.gmsflight
			and player.cmd.buttons & BT_JUMP
				-- amount of moms must be at 0
				if player.mo.momz < 0
				and not (player.mo.eflags & MFE_VERTICALFLIP)
					player.mo.momz = 0
				end
				-- inverted gravity check
				if player.mo.momz > 0
				and(player.mo.eflags & MFE_VERTICALFLIP)
					player.mo.momz = 0
				end
				-- the sprite
				player.mo.state = S_PLAY_DASH
				-- add player to the table
				sndtbl[player.name] = player.mo
				-- can carry players like tails
				player.pflags = $|PF_CANCARRY
				-- ring consumption timer
				if player.consumecooldown == 0
					player.rings = $-1
					player.consumecooldown = 35
				end
				-- flight dash trigger
				if player.spintapping
				and player.gmsdashcooldown == 0
					-- 20 moms
					P_SetObjectMomZ(player.mo, 20*FRACUNIT)
					P_InstaThrust(player.mo, player.mo.angle, player.actionspd)
					P_SpawnGhostMobj(player.mo)
					S_StartSound(player.mo, sfx_zoom)
					player.gmsdashcooldown = 35
					-- consume 10 rings or just drop to 0 if you have less
					-- disabled if super
					if not player.powers[pw_super]
						if player.rings < 10
							player.rings = 0
						else
							player.rings = $-10
						end
					end
				end
				-- cancel flight if ring mode is off
				if player.rcm == 0
					player.stillcarryafterlettinggo = true
					player.gmsflight = nil
					player.mo.state = S_PLAY_JUMP
					sndtbl[player.name] = nil
					S_StopSoundByID(player.mo, sfx_jet)
					player.pflags = $|PF_JUMPED
				end
				-- cancel flight if damaged
				if P_PlayerInPain(player)
					player.stillcarryafterlettinggo = nil
					player.gmsflight = nil
					player.mo.state = S_PLAY_PAIN
					sndtbl[player.name] = nil
					S_StopSoundByID(player.mo, sfx_jet)
					player.pflags = $&~PF_CANCARRY
				end
			-- cancel flight if not holding jump button	
			elseif player.gmsflight
				player.stillcarryafterlettinggo = true
				player.gmsflight = nil
				player.mo.state = S_PLAY_JUMP
				sndtbl[player.name] = nil
				S_StopSoundByID(player.mo, sfx_jet)
				player.pflags = $|PF_JUMPED
			end
			-- make sure you can still carry people as long as youre on the air and didnt get damaged
			if player.stillcarryafterlettinggo
				if P_IsObjectOnGround(player.mo)
				or P_PlayerInPain(player)
					player.stillcarryafterlettinggo = nil
					player.pflags = $&~PF_CANCARRY
				else
					player.pflags = $|PF_CANCARRY
				end
			end
			-- this cool code makes you able to use shields and super when ring mode is on if you hold jump
			if (player.rcm
			and not (player.cmd.buttons & BT_JUMP)
			and (player.pflags & PF_JUMPED))
			or player.gmsflight
				player.charflags = $|SF_NOSHIELDABILITY
				-- make sure the player is not already super to not cancel it out
				if not player.powers[pw_super]
					player.charflags = $&~SF_SUPER
				end
			else
				player.charflags = $&~SF_NOSHIELDABILITY
				player.charflags = $|SF_SUPER
			end
			-- stomp trigger
			if player.pflags & PF_JUMPED
			and not player.gmsflight
			and not (player.cmd.buttons & BT_JUMP)
			and not player.gmsstomp
			and player.spintapping
			and player.rcm
			and player.uncarry == false
			and player.powers[pw_carry] == CR_NONE
				S_StartSound(player.mo, sfx_zoom)
				-- you get NO moms
				-- this is so the startup animation starts adding from 0
				player.mo.momz = 0
				player.gmsstomp = 1
				-- consume 5 rings or just drop to 0 if you have less
				-- disabled if super
				if not player.powers[pw_super]
					-- beta behavior = 10 rings
					-- current behavior = 5 rings
					if player.gmsbetarc == true
						player.gdlkseanlog = 10
					else
						player.gdlkseanlog = 5
					end
					if player.rings < player.gdlkseanlog
						player.rings = 0
					else
						player.rings = $-player.gdlkseanlog
					end
				end
			end
			-- power spring with stomp
			if player.powers[pw_justsprung]
			and player.gmsstomp
				S_StopSoundByID(player.mo, sfx_spin)
				S_StartSound(player.mo, sfx_pstop)
				player.gmsstomp = nil
				player.pflags = $&~PF_JUMPED
				player.pflags =  $&~PF_SPINNING
				player.mo.state = S_PLAY_SPRING
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				player.mo.momz = $*5/4
				S_StartSound(player.mo, sfx_sprong)
			end
			-- stomp code loop
			if player.gmsstomp
				-- NO flying while stomping!! (repost to scare maxisuperpoke)
				player.gmsflight = nil
				-- cancel jet engine sfx
				S_StopSoundByID(player.mo, sfx_jet)
				-- i used the value itself as a timer for the starting animation, first part runs after the animation second is before
				if player.gmsstomp >= 5
					-- set crumbled to false to reset it from the last time it was set to true
					-- it will go back to true if all of this is met
					-- more efficient than using else in everything
					player.crumbled = false
					-- floor crumble, code edited from ssnmighty by my good ol friend sz
					if P_IsObjectOnGround(player.mo)
						for x=player.mo.x,player.mo.x+player.mo.radius,player.mo.radius
							for y=player.mo.y,player.mo.y+player.mo.radius,player.mo.radius
								local ss = R_PointInSubsector(x,y)
								for fof in ss.sector.ffloors()
									if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
										if (player.mo.z+player.mo.momz==fof.topheight or player.mo.z+player.mo.height+player.mo.momz==fof.bottomheight or (player.mo.eflags & MFE_VERTICALFLIP and (player.mo.z+player.mo.momz==fof.bottomheight or player.mo.z-player.mo.height-player.mo.momz==fof.topheight)))
											EV_CrumbleChain(ss.sector, fof)
											player.crumbled = true
											-- restore the moms
											player.restoremomz = true
											-- just in case
											S_StopSoundByID(player.mo, sfx_spin)
										end
									end
								end
							end
						end
						if player.crumbled == false
							-- no spin sound effect if you hold spin key!!!! idk weird thing srb2 does
							S_StopSoundByID(player.mo, sfx_spin)
							S_StartSound(player.mo, sfx_pstop)
							if player.powers[pw_super]
								P_NukeEnemies(player.mo, player.mo, 772*FRACUNIT)
							else
								P_NukeEnemies(player.mo, player.mo, 386*FRACUNIT)
							end
							player.gmsstomp = nil
							-- beta behavior = 10 moms
							-- current behavior = 5 moms
							if player.gmsbetarc == true
								P_SetObjectMomZ(player.mo, 10*FRACUNIT)
							else
								P_SetObjectMomZ(player.mo, 5*FRACUNIT)
							end
							-- speed it up a lil
							if player.speed < 10*FRACUNIT
								P_InstaThrust(player.mo, player.mo.angle, 10*FRACUNIT)
							end
							-- was too lazy to add damaging properties or a trail manually
							player.pflags = $|PF_SPINNING
							player.mo.state = S_PLAY_ROLL
							player.mo.spritexscale = FRACUNIT
							player.mo.spriteyscale = FRACUNIT
						end
					else
					-- code for the actual aerial activities
						-- restore momentum if the need to restore it is seen
						if player.restoremomz
							player.mo.momz = player.storemomzforcrumble
							player.restoremomz = nil
						end
						-- store your momentum for the previous function to work
						-- must run after to not make it pointless
						player.storemomzforcrumble = player.mo.momz
						-- adds momentum not sets. setobjectmomz adds momentum if third value is true
						P_SetObjectMomZ(player.mo, -5*FRACUNIT, true)
						player.mo.state = S_GMS_STRETCH
						player.pflags =  $&~PF_JUMPED
						player.pflags = $|PF_SPINNING
						-- funny stretch
						if player.mo.spritexscale > FRACUNIT/2
							player.mo.spritexscale = $-(FRACUNIT/5)
						end
						if player.mo.spriteyscale < (3*FRACUNIT)/2
							player.mo.spriteyscale = $+((3*FRACUNIT)/10)
						end
						-- ah yes i love spin trail
						if not player.rcmdashmode
							local gmsstompspinitem = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
							if gmsstompspinitem
								gmsstompspinitem.spritexscale = player.mo.spritexscale
								gmsstompspinitem.spriteyscale = player.mo.spriteyscale
								gmsstompspinitem.color = player.mo.color
							end
						end
					end
				else
				-- startup animation
					-- beta behavior: constant 1 fu/t
					-- current behavior: increasing by 2 fu/t every tic
					if player.gmsbetarc == true
						P_SetObjectMomZ(player.mo, FRACUNIT)
					else
						P_SetObjectMomZ(player.mo, 2*FRACUNIT, true)
					end
					player.mo.state = S_GMS_SQUASH
					-- funny squash
					if player.mo.spritexscale < (3*FRACUNIT)/2
						player.mo.spritexscale = $+((3*FRACUNIT)/10)
					end
					if player.mo.spriteyscale > FRACUNIT/2
						player.mo.spriteyscale = $-(FRACUNIT/10)
					end
					-- increase timer
					player.gmsstomp = $+1
					-- ah yes i love spin trail (2)
					-- beta did not have this
					if not player.rcmdashmode
					and player.gmsbetarc == false
						local gmsstompspinitem = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
						if gmsstompspinitem
							gmsstompspinitem.spritexscale = player.mo.spritexscale
							gmsstompspinitem.spriteyscale = player.mo.spriteyscale
							gmsstompspinitem.color = player.mo.color
						end
					end
				end
			end
		end
	end
end)

-- extra hook that runs locally to make sure the sound only plays for players with the command on
addHook("PlayerThink", function(player)
	for k,v in pairs(sndtbl) do
		if v != nil and userdataType(v) == "mobj_t" then
		-- v *SHOULD* be a proper player.mo
			-- play jet engine sound if not playing
			if not S_SoundPlaying(v, sfx_jet)
			and player.gmsnoise == true
				S_StartSound(v, sfx_jet, player)
			end
		end
	end
end)