-- funny hud code
-- special thanks to ashi for helping me display a graphic on the screen

-- i was gonna use playerthink and write to a local variable but i decided to play safe and use a player variable to get the right variable with hud.add
addHook("ThinkFrame", do
	for player in players.iterate
		-- loads betahud settings
		if player.gmsbetahud == nil
			local file = io.openlocal("client/terioswashere/gms_betahud.dat", "r")
			if file
				local string = file:read("*a")
				if string == "true"
					player.gmsbetahud = true
				else
					player.gmsbetahud = false
				end
			else
				player.gmsbetahud = false
			end
		end
		if (player.mo and player.mo.skin == "gms")
		and player.gmsbetahud == false
			-- go back to frame 1 if on frame 24 (last)
			-- also set to 1 if nonexistant to prevent mathematic issues
			if player.ringanim == nil
			or player.ringanim == 24
				player.ringanim = 1
			else
				-- only increase frame number when ring charge is on
				-- increase by 3 if abilities being used or you are super, by 1 if not
				if player.rcm
					if player.rcmdashmode
					or player.gmsflight
					or player.gmsstomp
					or player.powers[pw_super]
						player.ringanim = $+3
					else
						player.ringanim = $+1
					end
				end
			end
			-- set to 24 if higher
			-- since i use the number directly on the graphic name it will not be able to find it if its the wrong number
			if player.ringanim > 24
				player.ringanim = 24
			end
			-- flashing ring when super
			if player.powers[pw_super]
				if player.ringflash == nil
				or player.ringflash == 0
					player.ringflash = 1
				else
					player.ringflash = 0
				end
			else
				player.ringflash = 0
			end
		else
			player.ringanim = 1
			player.ringflash = 0
		end
	end
end)			

-- current hud function
hud.add(function(v, player, cam)
	if player.gmsbetahud == true
		return
	end
	if player.mo.skin == "gms"
	-- pls dont ruin the nights hud
	and not(mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS)
		if player.rcm
			if player.ringflash == 0
				-- nrng is nights ring hud graphic, number at the end is directly grabbed from ringanim value
				v.draw(130, 40, v.cachePatch("NRNG"..player.ringanim), V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS)
			else
				-- gmss is an alternate full white version to simulate flashing
				v.draw(130, 40, v.cachePatch("GMSS"..player.ringanim), V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS)
			end
		else
			-- gmsr is an alternate dark version added in the mod
			v.draw(130, 40, v.cachePatch("GMSR"..player.ringanim), V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS)
		end
	end
end)

-- beta hud function
hud.add(function(hud, player, cam)
	if player.gmsbetahud == false
		return
	end
	if player.mo.skin == "gms"
		if player.rcm ==1
			hud.drawString(310, 176, "RING CHARGE ON  ", V_ALLOWLOWERCASE,"right")
		else
			hud.drawString(310, 176, "RING CHARGE OFF", V_ALLOWLOWERCASE,"right")
		end
	end
end)