-- the supercolor

-- freeslot this shit
freeslot("SKINCOLOR_GMSSUPER")

-- the supercolor itself
-- i went for a lua animated skincolor to make it different from just a regular supercolor
skincolors[SKINCOLOR_GMSSUPER] = {
	name = "GMSSuper",
	ramp = {81,82,84,64,65,65,52,53,55,55,55,56,35,35,35,35},
	invcolor = SKINCOLOR_EMERALD,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

-- code for animated skincolors by yfyfyfyfyfy
local flashColors = {
	skincolors[SKINCOLOR_GMSSUPER]
}
local flashDelay = 1 //change this to how many tics it takes to animate

local rampPos = 1
local rampDir = true
local ramps = {}

for curcol = 1, table.maxn(flashColors), 1
	ramps[curcol] = {{}}
	for i = 0, 15, 1
		ramps[curcol][1][i+1] = flashColors[curcol].ramp[i]
	end

	for i = 2, 16,1
		ramps[curcol][i] = {{}}

		for pos,val in ipairs(ramps[curcol][i-1]) do
			if not (pos == 16) then
				ramps[curcol][i][pos+1] = val
			else
				ramps[curcol][i][1] = val
			end
		end
	end
end

local function RampWave()
	if not (leveltime % flashDelay) then

		rampPos = $1+1
		
		//too high, time to go back
		if not (ramps[1][rampPos])
			rampPos = 1
		end
		
		for i = 1, table.maxn(ramps), 1
			flashColors[i].ramp = ramps[i][rampPos]
		end
	end
end

addHook("ThinkFrame", RampWave)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "gms")
			-- put supercolor on when super
			if(player.powers[pw_super]
			-- xmomentum hyper exists!!!!!!!!!!!
			and not(player.hyper
			and player.hyper.capable)
			-- first frames of super transformation are considered super too despite not having the regular super color so exclude em
			and not(player.mo.state >= S_PLAY_SUPER_TRANS1
			and player.mo.state <= S_PLAY_SUPER_TRANS5))
			-- put supercolor on when nights
			or(player.powers[pw_carry] == CR_NIGHTSMODE
			and not(player.mo.state >= S_PLAY_NIGHTS_TRANS1
			and player.mo.state <= S_PLAY_NIGHTS_TRANS5))
				player.mo.color = SKINCOLOR_GMSSUPER
			end
		end
	end
end)

-- more code from the teen sonic mod i was helped to make
-- i still cannot recall this persons name
addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "gms"
		if player.powers[pw_super]
			local r = player.mo.radius/FRACUNIT
			local xy = (P_RandomRange(r, -r)*FRACUNIT)
			local z = (P_RandomKey(player.mo.height/FRACUNIT)*FRACUNIT)
			P_SpawnMobj(player.mo.x + xy, player.mo.y + xy, player.mo.z + z, MT_WATERZAP)
		end
	end
end)